/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.fel.k333.jerseytest.rest;

import cz.fel.k333.jerseytest.Person;
import java.util.Enumeration;
import java.util.LinkedList;
import java.util.List;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;
import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;

/**
 *
 * @author zdenekkouba
 */
@Path("/person")
public class JSONService {
    
    private Person addToSession(String gName, String fName, HttpSession session) {
        String key = "person#" + gName.toUpperCase()+fName.toUpperCase();
        Person person = (Person) session.getAttribute(key);
        if (person == null) {
            person = new Person();
            person.setGivenName(gName);
            person.setFamilyName(fName);
            session.setAttribute(key,person);
        }
        return person;        
    }

    @GET
    @Path("/all")
    @Produces(MediaType.APPLICATION_JSON)
    public List<Person> getAllPersons(@Context HttpServletRequest req) {
        HttpSession session = req.getSession();
        List<Person> persons = new LinkedList<Person>();
        Enumeration<String> attribNames = session.getAttributeNames();
        while (attribNames.hasMoreElements()) {
            String attrName = attribNames.nextElement();
            if (attrName != null && attrName.startsWith("person#")) {
                persons.add((Person) session.getAttribute(attrName));
            }
        }
        return persons;

    }

    @GET
    @Path("/new")
    @Produces(MediaType.APPLICATION_JSON)
    public Person getPersonAsObject(@Context HttpServletRequest req) {
        System.out.println("getPersonInJSON called");
        return addToSession("Jan", "Novak", req.getSession());
    }
    
    @GET
    @Path("/textpath/{given_name}/{family_name}")
    @Produces(MediaType.APPLICATION_JSON)
    public Person getPersonAsText(@PathParam("given_name") String gName, @PathParam("family_name") String fName, 
                                  @Context HttpServletRequest req) {
        HttpSession session = req.getSession();
        return addToSession(gName, fName, session);
    }
 
    @GET
    @Path("/textparam")
    @Produces(MediaType.APPLICATION_JSON)
    public Person getPersonAsTextParam(@QueryParam("given_name") String gName, 
                                       @QueryParam("family_name") String fName,
                                       @Context HttpServletRequest req) {
        HttpSession session = req.getSession();
        return addToSession(gName, fName, session);
    }
 
    
    @POST
    @Path("/rename/{newGName}/{newFName}")
    @Consumes(MediaType.APPLICATION_JSON)
    @Produces(MediaType.APPLICATION_JSON)
    public Person rename(@PathParam("newGName") String newGName, 
                         @PathParam("newFName") String newFName,
                         Person person) {
        person.setGivenName(newGName);
        person.setFamilyName(newFName);
        return person;
    }
    
    
}
